<?php
defined('TYPO3_MODE') or die();

// Configuration of authentication service.
$EXT_CONFIG = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['ig_ldap_sso_auth']);

// SSO configuration
if ((bool)$EXT_CONFIG['enableFESSO']) {
	$GLOBALS['TYPO3_CONF_VARS']['SVCONF']['auth']['setup']['FE_fetchUserIfNoSession'] = 1;
}

// Visually change the record icon for FE/BE users and groups
$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_iconworks.php']['overrideIconOverlay'][] = 'EXT:' . $_EXTKEY . '/Classes/Hooks/DatabaseRecordListIconUtility.php:Tx_IgLdapSsoAuth_Hooks_DatabaseRecordListIconUtility';
$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['typo3/class.db_list_extra.inc']['getTable'][] = 'EXT:' . $_EXTKEY . '/Classes/Hooks/DatabaseRecordListIconUtility.php:Tx_IgLdapSsoAuth_Hooks_DatabaseRecordListIconUtility';

// Service configuration
$subTypesArr = array();
$subTypes = '';
if ($EXT_CONFIG['enableFELDAPAuthentication']) {
	$subTypesArr[] = 'getUserFE';
	$subTypesArr[] = 'authUserFE';
	$subTypesArr[] = 'getGroupsFE';
}
if ($EXT_CONFIG['enableBELDAPAuthentication']) {
	$subTypesArr[] = 'getUserBE';
	$subTypesArr[] = 'authUserBE';

	$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/setup/mod/index.php']['modifyUserDataBeforeSave'][] = 'EXT:' . $_EXTKEY . '/Classes/Hooks/SetupModuleController.php:Tx_IgLdapSsoAuth_Hooks_SetupModuleController->preprocessData';
}
if (is_array($subTypesArr)) {
	$subTypesArr = array_unique($subTypesArr);
	$subTypes = implode(',', $subTypesArr);
}

// Register hook for \TYPO3\CMS\Core\DataHandling\DataHandler
$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_tcemain.php']['processDatamapClass'][] = 'EXT:' . $_EXTKEY . '/Classes/Hooks/DataHandler.php:Tx_IgLdapSsoAuth_Hooks_DataHandler';

// Register the synchronize users Scheduler task
$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['scheduler']['tasks']['tx_igldapssoauth_scheduler_synchroniseusers'] = array(
	'extension'   => $_EXTKEY,
	'title'       => 'LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/locallang.xml:synchro.name',
	'description' => 'LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/locallang.xml:synchro.description'
);
// Register the import users Scheduler task
$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['scheduler']['tasks']['Tx_IgLdapSsoAuth_Task_ImportUsers'] = array(
	'extension'			=> $_EXTKEY,
	'title'				=> 'LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/locallang.xml:task.import_users.title',
	'description'		=> 'LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/locallang.xml:task.import_users.description',
	'additionalFields'	=> 'Tx_IgLdapSsoAuth_Task_ImportUsersAdditionalFields'
);

$serviceInfo = array(
	'title' => 'Authentication service',
	'description' => 'Authentication service for LDAP and SSO environment.',

	'subtype' => $subTypes,

	'available' => TRUE,
	'priority' => 80,
	'quality' => 80,

	'os' => '',
	'exec' => '',

	'classFile' => t3lib_extMgm::extPath($_EXTKEY) . 'Classes/Service/Sv1.php',
	'className' => 'tx_igldapssoauth_sv1',
);
if (version_compare(TYPO3_version, '6.1.0', '>=')) {
	unset($serviceInfo['classFile']);
}
t3lib_extMgm::addService($_EXTKEY,  'auth' /* sv type */,  'tx_igldapssoauth_sv1' /* sv key */, $serviceInfo);

// User have save doc new button
t3lib_extMgm::addUserTSConfig('options.saveDocNew.tx_igldapssoauth_config=1');
